namespace WorkerTaskDelayWithCancellation;

public class Worker : BackgroundService
{
    protected override async Task ExecuteAsync(CancellationToken stoppingToken)
    {
        while (!stoppingToken.IsCancellationRequested)
        {
            Console.WriteLine($"Worker running at: {DateTime.Now:HH:mm:ss}");
            //await Task.Delay(1000, stoppingToken); // does not throw TaskCanceledException and won't execute the cleanup code
            //await Task.Delay(1000, stoppingToken).ConfigureAwait(ConfigureAwaitOptions.SuppressThrowing); // won't exit the loop 
            //await Task.Delay(1000, stoppingToken).ContinueWith(t =>  { return t.Exception == default;}); // won't exit the loop 
            try 
            {
                await Task.Delay(1000, stoppingToken);
            }
            catch (TaskCanceledException)
            {
                Console.WriteLine($"Cancelled during the Task.Delay(...).");
                break;
            }
            Console.WriteLine($"Still in loop running at: {DateTime.Now:HH:mm:ss}");

        }
        Console.WriteLine("Cancellation requested, doing some cleanup.");
    }
}
